;;; @file c64.s
;;; Common definitions for the Commodore 64 and 128
;;; @author Marko Mkel (msmakela@nic.funet.fi)

cashdr	= 3	; cassette buffer header
stemp	= $a7	; placeholder for the byte being received

;;; Commodore cassette port definitions
c2nread	= $dc0d
c2nrdval	= 16
c2nwrite	= 1
c2nwrval	= 8

;; wait for high-to-low transition on CASS READ
#define c2nrdlo lda #c2nrdval:.(:wait bit c2nread:beq wait:.)
;; wait for low-to-high transition on CASS READ
#define c2nrdhi
;; clear the status of the CASS READ line
#define c2nclrd
;; lower or raise the cassette write line
#define c2nwr0 and #255-c2nwrval
#define c2nwr1 ora #c2nwrval
;; invert the read byte if needed
#define invert eor #$ff
