;;; @file vic20/host.s
;;; Commodore VIC-20 definitions
;;; @author Marko Mkel (msmakela@nic.funet.fi)

bend	= $2d	; end of basic program text
ibsout	= $326	; KERNAL CHROUT routine
;; restore (among others) the IBSOUT vector and let carry be clear
#define restor jsr $ff8a

casbuf	= $33c	; the start address of the cassette buffer
cashdr	= 3	; cassette buffer header
stemp	= $a7	; placeholder for the byte being received

;; keyboard buffer
keylen	= $c6		; length in bytes
keybuf	= $277		; data

;;; Commodore cassette port definitions
c2nread = $912d			; VIA Interrupt Flag Register
c2nrdval = 2			; CA1 (cassette read)
c2nwrite = $9120		; VIA output register B
c2nwrval = 8			; PB3 (cassette write)

;; wait for high-to-low transition on CASS READ
#define c2nrdlo lda #c2nrdval:.(:wait bit c2nread:beq wait:.)
;; wait for low-to-high transition on CASS READ
#define c2nrdhi
;; clear the status of the CASS READ line
#define c2nclrd sta c2nread
;; lower or raise the cassette write line
#define c2nwr0 and #255-c2nwrval
#define c2nwr1 ora #c2nwrval
;; invert the read byte if needed
#define invert eor #$ff
