%define name cbm4linux
%define ver 0.3.1
Summary: CBM4Linux kernel module, runtime libraries and utilities
Name: %{name}
Version: %{ver}
Release: 1
Group: Applications/System
Copyright: GPL
Source: http://www.lb.shuttle.de/puffin/cbm4linux/%{name}-%{ver}.tar.gz
Buildroot: /var/tmp/%{name}
Url: http://www.lb.shuttle.de/puffin/cbm4linux

Group: Applications/System

%description
The cbm4linux package is a linux kernel module and a few user space support
programs to control and use serial devices as used by most Commodore (CBM)
8-bit machines, such as disk drives and printers from your trusty C64.
A fast .d64 transfer program is included.

%package devel
Summary: CBM4Linux linktime libraries and header files
Group: Development/Libraries
Requires: %{name} = %{ver}

%description devel
Libraries and header files for cbm4linux.

%prep
%setup

%build
make

%post
/sbin/ldconfig
/sbin/depmod -a
install-info --entry="* cbm4linux: (cbm4linux).	cbm4linux users guide" %{_infodir}/%{name}.info.gz %{_infodir}/dir

%preun
if [ "$1" = 0 ]; then
  install-info --delete %{_infodir}/%{name}.info.gz %{_infodir}/dir
fi

%install
rm -rf $RPM_BUILD_ROOT
make install \
	PREFIX=$RPM_BUILD_ROOT/%{_prefix} \
	BINDIR=$RPM_BUILD_ROOT/%{_bindir} \
	LIBDIR=$RPM_BUILD_ROOT/%{_libdir} \
	MANDIR=$RPM_BUILD_ROOT/%{_mandir}/man1 \
	INFODIR=$RPM_BUILD_ROOT/%{_infodir} \
	INCDIR=$RPM_BUILD_ROOT/%{_includedir} \
	MODDIR=$RPM_BUILD_ROOT/"`for d in /lib/modules/\`uname -r\`/{misc,kernel/drivers/char}; do test -d $d && echo $d; done | head -1`"

gzip -9 $RPM_BUILD_ROOT/%{_mandir}/man1/*
make dev CBMDEV=$RPM_BUILD_ROOT/dev/cbm

%files
%defattr(-,root,root)
%doc README COPYING NEWS CABLE
%doc docs/*
%{_bindir}/*
%{_infodir}/*
%{_libdir}/lib*.so.*
%{_mandir}/man1/*
/lib/modules
/dev/cbm

%files devel
%defattr(-,root,root)
%{_includedir}/*
%{_libdir}/lib*.so

%clean
rm -rf $RPM_BUILD_ROOT
