/*
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version
 *  2 of the License, or (at your option) any later version.
 *
 *  Copyright 2002 Michael Klein <michael.klein@puffin.lb.shuttle.de>
 */

#ifdef SAVE_RCSID
static char *rcsid =
    "@(#) $Id: petscii.c,v 1.1 2002/03/12 21:00:39 michael Exp $";
#endif

#include <ctype.h>

#include "../include/opencbm.h"


/*
 * some parts of this code are stolen from VICE's charset.c, written by
 *  Jouko Valta <jopi@stekt.oulu.fi>
 *  Andreas Boose <boose@linux.rz.fh-hannover.de>
 */


/* 98% stolen */
int cbm_petscii2ascii_c(int c)
{
    switch (c & 0xff) {
      case 0x0a:
      case 0x0d:
          return '\n';
      case 0x40:
      case 0x60:
        return c;
      case 0xa0:                                /* CBM: Shifted Space */
      case 0xe0:
        return ' ';
      default:
        switch (c & 0xe0) {
          case 0x40: /* 41 - 7E */
          case 0x60:
            return (c ^ 0x20);

          case 0xc0: /* C0 - DF */
            return (c ^ 0x80);

      }
    }

    return ((isprint(c) ? c : '.'));
}

/* 99% stolen */
int cbm_ascii2petscii_c(int c)
{
    if ((c >= 0x5b) && (c <= 0x7e))
        return c ^ 0x20;
    else if ((c >= 'A') && (c <= 'Z'))          /* C0 - DF */
        return c | 0x80;
    return c;
}


char *cbm_petscii2ascii(char *str)
{
    unsigned char *p;
    for(p = str; *p; p++) *p = cbm_petscii2ascii_c(*p);
    return str;
}

char *cbm_ascii2petscii(char *str)
{
    unsigned char *p;
    for(p = str; *p; p++) *p = cbm_ascii2petscii_c(*p);
    return str;
}

