/*
 * Copyright  1994-1996 Marko Mkel and Olaf Seibert
 * Original Linux and Commodore 64/128/Vic-20 version by Marko Mkel
 * Ported to the PET and the Amiga series by Olaf Seibert
 * 
 *     This program is free software; you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation; either version 2 of the License, or
 *     (at your option) any later version.
 * 
 *     This program is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 * 
 *     You should have received a copy of the GNU General Public License
 *     along with this program; if not, write to the Free Software
 *     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/* Define some useful macros. */

/* Is there any better way to detect Amiga? */
#ifndef MSDOS	/* this is for avoiding an error with MS-DOS compilers */
#  if #cpu (m68k)	/* this is gcc specific */
#  define __amiga__
#  endif
#endif

/* First make some obfuscating definitions to get the module names
   into the transfer function declarations, e.g. prinit_prtrans1.
   This allows all protocols to be integrated into one executable. */

#if defined (__PRTRANS1_C__)
#  define P(func) func ## _prtrans1
#elif defined (__PRTRANS2_C__)
#  define P(func) func ## _prtrans2
#elif defined (__PRTRANS4_C__)
#  define P(func) func ## _prtrans4
#elif defined (__PRTRANS8_C__)
#  define P(func) func ## _prtrans8
#elif defined (__PRAMIGA_C__)
#  define P(func) func ## _pramiga
#endif

/* If there will be only one transfer module in an executable (fixed
   protocol), the function names must be like prinit, prclose and so
   on, without the module suffix.

   In prmain.c, the transfer functions will be declared as pointers,
   which are exported in other modules, unless they are compiled for a
   fixed protocol.  */

#define E

#if (defined(__MAIN_C__) && defined(P)) || defined(__PRMAIN_C__)
unsigned baseaddr = 0, stataddr = 0, ctrladdr = 0;
unsigned portaddr[] = {0x3BC, 0x378, 0x2BC, 0x278};
#else
extern unsigned baseaddr, stataddr, ctrladdr;
extern unsigned portaddr[];
#endif

#ifdef __MAIN_C__
#  if defined(P)               /* a transfer module, fixed protocol option */
#    undef P
#    define P(func) func
#  elif defined(__PRMAIN_C__)  /* prmain.c: declare the function pointers */
#    define P(func) (*func)
#  else                        /* any other module, fixed protocol option */
#    define P(func) func
#  endif
#elif !defined(P)              /* the transfer functions must be pointers */
#  define P(func) (*func)
#  undef E
#  define E extern
#else
#endif

#define prinit P(prinit)
#define prclose P(prclose)
#define input P(input)
#define output P(output)
#define send_switch P(send_switch)
#define receive_switch P(receive_switch)
#define preceive P(preceive)
#define psend P(psend)
#ifndef MSDOS
#  define wait_input P(wait_input)
#  define wait_output P(wait_output)
#endif

#include "prtransd.h" /* include the actual prototypes */

typedef int main_t(int argc, char **argv);

extern main_t main_prload, main_prsave, main_prcart,
	      main_prrfile, main_prwfile, main_prdisk;

extern int findcable (char *name);

#define SLEEP_TIME 10000 /* amount of microseconds to wait in wait_input */

#ifdef MSDOS
#  define outb(data,port) outp(port,data)
#  define inb inp
#endif /* MSDOS */

/* some definitions for inline assembler usage */

#ifdef __GNUC__
#  ifndef NO_ASM
#    if defined(__i386__) || defined(__i486__) || defined(__i586__)
#      define GAS_ENABLED
#    endif
#  endif
#endif

#ifdef _MSC_VER
#  ifndef NO_ASM
#    define MASM_ENABLED
#  endif
#  if defined(_M_I286) || defined(_M_I386)
#    define USE286
#  endif
#endif

#define REQ_INFO 0
#define REQ_LOAD 1
#define REQ_SAVE 2
#define REQ_JUMP 3
#define REQ_RUN  4

#ifndef DEFAULT_PORT
#  define DEFAULT_PORT 0
#endif

#ifndef TRUE
#  define TRUE (1)
#  define FALSE (0)
#endif

#ifdef BUFSIZE
#  ifdef __MAIN_C__
unsigned char buffer[BUFSIZE];
#  else
extern unsigned char buffer[BUFSIZE];
#  endif /* __MAIN_C__ */
#endif /* BUFSIZE */
