/*
 * Copyright  1994-1996 Marko Mkel and Olaf Seibert
 * Original Linux and Commodore 64/128/Vic-20 version by Marko Mkel
 * Ported to the PET and the Amiga series by Olaf Seibert
 * 
 *     This program is free software; you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation; either version 2 of the License, or
 *     (at your option) any later version.
 * 
 *     This program is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 * 
 *     You should have received a copy of the GNU General Public License
 *     along with this program; if not, write to the Free Software
 *     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/* Declare the transfer functions. */

E int prinit (void);			/* initializes the routines */
E void prclose (void);			/* closes the routines */

E void output (unsigned char byte);	/* outputs a byte */
E unsigned input (void);		/* inputs a byte */
E void send_switch (void);		/* switches from receive to send */
E void receive_switch (void);		/* switches from send to receive */
#ifndef MSDOS
E void wait_output (unsigned char byte);/* output, without busy-waiting */
E unsigned wait_input (void);		/* input, without busy-waiting */
#else
#  define usleep(x)			/* Microsoft only knows busy-waiting */
#  define wait_output output
#  define wait_input input
#endif

E void psend (unsigned char *buffer, unsigned length);	 /* sends bytes */
E void preceive (unsigned char *buffer, unsigned length);/* receives bytes */
