; target system options

c128	= 1
c16	= 2
c64	= 4
vic20	= 8
pet3001 = 16
pet4001 = 32

; memory expansion types

none	= 0
piaexp	= 1 ; 256kB on the C64 or 512 or 1024 kB on the C128
reuexp	= 2 ; Commodore RAM Expansion Unit
actionreuplay	= 0	; set this to 1 if using REU and
				; Action Replay simultaneously.
pet96	= 4 ; PET 8096/8296 expansion

; cable types

prlink	= 1 ; A 8-bit/4-bit cable, the default.
pc64	= 2 ; A 4-bit/4-bit cable used by the PC64 emulator.
c64net	= 4 ; A 4-bit/2-bit cable used by the 64net program.  Very slow.
prlink88 = 8 ; A 8-bit/8-bit cable
transnib = 16 ; A 4-bit/4-bit cable used by TransNib V1.00
iec	= 32 ; Commodore serial bus
x1541	= 32 ; (the X1541 or
disk64e	= 32 ; Disk64e cable)
kontros = 64 ; Frank Kontros' 8-bit/8-bit cable with hardware handshaking

;;;;
;
; The settings below are used in multiple assembler sources


#if target & c128
prsrv	= $1300
prutils = $1700
#endif
#if target & c16
prsrv	= $4000
prutils	= $4800
#endif
#if target & c64
;prsrv	= $0400
prsrv	= $cd00
;prsrv	= $c900
prutils = $c000
#endif
#if target & vic20
prsrv	= $a000 ; memory expansion at BLK2 assumed
prutils = $4400
#endif
#if target & (pet3001 | pet4001)
memsize = 32 * 1024	;; 32 K
prsrv  = memsize - $200
;prsrv	 = 34768
;prsrv	 = $a000
prutils = memsize - $800
petb480 = 1
petb440 = 0
#endif

#if target & (c128 | c64)
#if ramexp & piaexp
pia	= $d7f0	; the PIA base address.
#endif
#if ramexp & reuexp
reu	= $df00	; the REU base address.
reubmin	= $10	; smallest bank number that refers to the REU banks
#endif
#endif		; target & (c128 | c64)
